using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Slb.Production.Common.Diagnostics;
using Slb.Production.Ofm.Api.PlugIn;
using Slb.Production.Ofm.Api;
using System.Collections.ObjectModel;


namespace TypeCurves_PluginAnalysis
{
    [OfmAnalysis(name: "TypeCurves_PluginAnalysis", largeImageUri: "TypeCurves_PluginAnalysis.Properties.Resources/Plug",
        smallImageUri: "TypeCurves_PluginAnalysis.Properties.Resources/Plug")]
    public class TypeCurves_PluginAnalysisPluginModel : Analysis<TypeCurves_PluginAnalysisPluginModel>
    {

        #region Properties

        public List<string> OFMVariables
        {
            get { return _ofmVariables; }
            set
            {
                if (_ofmVariables == value) return;
                _ofmVariables = value;

                OnPropertyChanged("OFMVariables");
            }
        }     // Property to display OFM Variables
        public List<string> _ofmVariables;
        public string SelectedVariable
        {
            get { return _selectedVariable; }
            set
            {
                if (_selectedVariable == value) return;
                _selectedVariable = value;
                CDFVariable = _selectedVariable;

                // Evaluate();
                OnPropertyChanged("SelectedVariable");
            }
        }               // Property to define OFM Variable to perform CDF calculations
        public string _selectedVariable;


        public List<string> OFMCategories         // Property to display OFM Categories
        {
            get { return _ofmCategories; }
            set
            {
                if (_ofmCategories == value) return;
                _ofmCategories = value;
                OnPropertyChanged("OFMCategories");
            }
        }
        public List<string> _ofmCategories;


        public string _selectedCategory;
        public string SelectedCategory                  // Property to define selected category 
        {
            get { return _selectedCategory; }
            set
            {
                if (_selectedCategory == value) return;
                _selectedCategory = value;

                OFMCategoriesNames = GetCatValues(_selectedCategory);     //call categoriesvalues function based on selected category

                OnPropertyChanged("SelectedCategory");
            }
        }

        public List<string> OFMCategoriesNames
        {
            get { return _oFMCategoriesNames; }
            set
            {
                if (_oFMCategoriesNames == value) return;
                _oFMCategoriesNames = value;
                OnPropertyChanged("OFMCategoriesNames");
            }
        }     // Property to display OFM Categories Values
        public List<string> _oFMCategoriesNames;



        public List<string> SelectedCatValues
        {
            get { return _selectedCatValues; }
            set
            {
                if (_selectedCatValues == value) return;
                _selectedCatValues = value;
                OnPropertyChanged("SelectedCatValues");
            }
        }     // Property to display OFM Categories Names
        public List<string> _selectedCatValues;

        public string SelectedVariableP10
        {
            get { return _selectedVariableP10; }
            set
            {
                if (_selectedVariableP10== value) return;
                _selectedVariableP10= value;
               P10var = _selectedVariableP10;

                OnPropertyChanged("SelectedVariableP10");
            }
        }               // Property to define OFM Variable to perform CDF calculations
        public string _selectedVariableP10;

        public string SelectedVariableP50
        {
            get { return _selectedVariableP50; }
            set
            {
                if (_selectedVariableP50 == value) return;
                _selectedVariableP50 = value;
                P50var = _selectedVariableP50;

                OnPropertyChanged("SelectedVariableP50");
            }
        }               // Property to define OFM Variable to perform CDF calculations
        public string _selectedVariableP50;

        public string SelectedVariableP90
        {
            get { return _selectedVariableP90; }
            set
            {
                if (_selectedVariableP90 == value) return;
                _selectedVariableP90 = value;
                P90var = _selectedVariableP90;

                OnPropertyChanged("SelectedVariableP90");
            }
        }               // Property to define OFM Variable to perform CDF calculations
        public string _selectedVariableP90;


        #endregion

        public string CDFVariable;
        public string P10var;
        public string P50var;
        public string P90var;
        public string ofmpathname;


        protected override void Initialize(IStatus status)
        {

        }

        protected override void HandleCurrentEntityChanged(IStatus status)
        {
        }

        protected override void HandleCurrentFilterChanged(IStatus status)
        {
        }
        protected override void HandleCurrentCategoryChanged(Slb.Production.Common.Diagnostics.IStatus status)
        {
        }
        protected override void CreateOfmType(OfmTypeBuilder<TypeCurves_PluginAnalysisPluginModel> typeBuilder)
        {
        }
        protected override ViewHandle CreateView(ViewHandleBuilder viewHandleBuilder, Slb.Production.Common.Diagnostics.IStatus status)
        {
            var view = new TypeCurves_PluginAnalysisPluginView();
            view.DataContext = this;
            return viewHandleBuilder.SetUIElementHandle(view);
        }

        public TypeCurves_PluginAnalysisPluginModel()
        {
            _ofmVariables = Workspace.Variables.Select(v => v.Name).ToList();        // Pick OFM Variables
            _ofmCategories = Workspace.Categories.Select(v => v.Name).ToList();      // Pick OFM Categories
            CDFVariable = _selectedVariable;
           

        }

        public void Initialize()
        {

        }


        //public List<KeyValuePair<double, double>> FinalResult
        //{
        //    get
        //    {
        //        return _finalResult;
        //    }
        //    set
        //    {
        //        if (_finalResult == value) return;
        //        _finalResult = value;
        //        OnPropertyChanged("FinalResult");
        //    }
        //}
        //public List<KeyValuePair<double, double>> _finalResult;

        public class CDFPlot
        {
            public List<double> CDFVal { get; set; }
            public List<double> VariableVal { get; set; }
            
            public DateTime dt { get; set; }
            public double value { get; set; }
            public double elapsedmonths { get; set; }  // JAN 2015

            public List<KeyValuePair<DateTime, double>> FinalResult { get; set; }
          
            //public double SampleCount { get; set; }
            public string categoryname { get; set; }
            public CDFPlot()
            {
                FinalResult = new List<KeyValuePair<DateTime, double>>();
            }
        }

        public class Typecurves
        {
            public List<CDFPlot> DataPoints { get; set; }

            public string categoryname { get; set; }

            public string catname_db { get; set; }   //added in Jan2015

            public Typecurves()
             {
                 DataPoints = new List<CDFPlot>();
             }
        }


        ObservableCollection<Typecurves> CDFresults = new ObservableCollection<Typecurves>();
        public ObservableCollection<Typecurves> CDFResults
        {
            get { return CDFresults; }
            set
            {
                CDFresults = value;
                base.OnPropertyChanged("StringList");
            }
        }

        ObservableCollection<CDFPlot> CDFPlotcollection = new ObservableCollection<CDFPlot>();
        public ObservableCollection<CDFPlot> CDFPlotCollection
        {
            get { return CDFPlotcollection; }
            set
            {
                CDFPlotcollection = value;
                base.OnPropertyChanged("StringList");
            }
        }


        #region MainEvaluate

        public void Evaluate()
        {
            // CDFResults.Clear();

            CDFPlot X = new CDFPlot();
            Typecurves TC = new Typecurves();

            var completionNames = new List<Completion>();
            

            var Best3MosGasRateValues = new List<double>();

            ofmpathname = Workspace.WorkspacePath.ToString();


            DateTime Sdate = default(DateTime);

            

           

            #region Normalization Date
            Result<double> InitialProdResult;

            List<double> InitialProdResult_Val_List = new List<double>();
            var Entity = Workspace.CurrentFilter;
            var completions_in_filter = Entity.Completions.ToList();
            double InitialProdMonth;
            var resetSums = Workspace.Variables["ResetSums"];
            foreach (var comp in completions_in_filter)
            {
                var InitialProd = this.Workspace.Variables["InitialProdDate"];
                InitialProdResult = Workspace.ResultsServices.EvaluateVariable<double>(comp, InitialProd);
                var InitialProdResult_Val = InitialProdResult.Values.FirstOrDefault();
                if (!double.IsNaN(InitialProdResult_Val))
                    InitialProdResult_Val_List.Add(InitialProdResult_Val);

                Workspace.ResultsServices.EvaluateVariable<double>(comp, resetSums);

            }


            var ListAscend = InitialProdResult_Val_List.OrderBy(x => x).Where(x => x > 0).ToList();
            InitialProdMonth = ListAscend.FirstOrDefault();

            if (double.IsNaN(InitialProdMonth))       //This checks in case the last date of Injection is EMPTY for a pattern
            {
                Sdate = default(DateTime);

            }
            else
            {
                Sdate = OfmDateUtility.DateUtilities.OfmDateToDateTime(InitialProdMonth);       // USES a DATE Utility

            }


            #endregion




            if (!(CDFVariable == null))  // dont start the calculations until users select a variable
            {

                // pick category , category values, find completions within that category and run calculations
                #region Main FOR LOOP
                foreach (var cat in SelectedCatValues)
                {
                    TC = new Typecurves();
                    completionNames = GetCompletionNames(SelectedCategory, cat);    //get completions list in the current filter for the category and category value

                    var Best3MosGasRate = Workspace.Variables[CDFVariable];        // get values for whichever variable selection in the dropdown

                    List<DateTime> OrderedTimes = new List<DateTime>();
                    var OrderedValues = new List<double>();
                    

                    var q10 = CDFResults.Where(C => C.categoryname == string.Format("P10:"+SelectedVariable+cat)).FirstOrDefault();      //find if the categoryvalue was already selected; dont run calculations
                    var q50 = CDFResults.Where(C => C.categoryname == string.Format("P50: " + SelectedVariable + " " + cat)).FirstOrDefault();      //find if the categoryvalue was already selected; dont run calculations
                    var q90 = CDFResults.Where(C => C.categoryname == string.Format("P90: " + SelectedVariable + " " + cat)).FirstOrDefault();      //find if the categoryvalue was already selected; dont run calculations
                    //if (q != null)                                                                //find if the categoryvalue was already selected; dont run calculations
                    //{
                    //   continue;
                    //}

                    //var match = CDFResults.FirstOrDefault(p => p.categoryname == string.Format("P10: " + SelectedVariable + " " + cat));
                    //if (match == null)
                    //{
                    //    // Element doesn't exist
                    //}
                    Dictionary<DateTime, List<double>> dict = new Dictionary<DateTime, List<double>>(); //Define a dictionary to store date and associated list of values


                    foreach (var comp in completionNames)
                    {

                        var completionResult = Workspace.ResultsServices.EvaluateVariable<double>(comp, Best3MosGasRate);

                        var NormalizationDate = Sdate;

                        foreach (var x in completionResult.SampleTimes)                               // Normalize the list to the Norm Date
                        {
                            List<double> values;
                            if (!dict.TryGetValue(NormalizationDate, out values))
                            {
                                values = new List<double>();
                                dict[NormalizationDate] = values;
                            }
                            if (double.IsNaN(completionResult.GetValueAtTime(x)))
                            {
                                values.Add(0);                                          // converts NULL to 0
                            }
                            else
                            {
                                values.Add(completionResult.GetValueAtTime(x));
                            }

                            NormalizationDate = NormalizationDate.AddMonths(1);                // since on monthlydata

                        } // end of foreach

                        //  Workspace.ResultsServices.EvaluateVariable<double>(comp, resetSums);

                    }  // end of foreach loop

                    var sortedDict1 = new Dictionary<DateTime, List<double>>();

                    foreach (var keyValuePair in dict)
                    {
                        sortedDict1[keyValuePair.Key] = new List<double>(keyValuePair.Value.OrderBy(x => x));  //Sort the dictionary
                    }

                    // ADD a condition if the user clicks P10 or P50 or P90
                    #region P10 CURVE
                    if (P10var == "P10" & q10 == null)
                    {
                        foreach (var keyValuePair in sortedDict1)
                        {
                            var kvalues = sortedDict1[keyValuePair.Key];
                            double N = kvalues.Count;  // number of completions in the current group List
                            double p10 = 10;
                            double n10 = (p10 / 100) * (N - 1) + 1;
                            double K10 = Math.Floor(Math.Abs(n10));
                            int d10 = 0;
                            d10 = (int)Math.Round((n10 - Math.Truncate(n10)) * 10);


                            // P10 Calc---------------------------------------------------
                            double kvalue_1 = 0;
                            var p1 = Convert.ToInt32(K10);
                            p1 = p1 - 1;
                            var kvalue1 = GetItemIfinIndex(p1, kvalues);
                            if (double.IsNaN(kvalue1))                          // check if the value is NULL
                            {
                                kvalue1 = 0;

                            }

                            if (double.IsNaN(GetItemIfinIndex(p1 + 1, kvalues)))    // check if the value is NULL
                            {
                                kvalue_1 = 0;

                            }
                            else
                            {
                                kvalue_1 = GetItemIfinIndex(p1 + 1, kvalues);
                            }


                            double x1 = (Convert.ToDouble(d10)) / 10;
                            var resultP10 = kvalue1 + x1 * (kvalue_1 - kvalue1);
                            // End P10 Calc----------------------------------------
                            OrderedValues.Add(resultP10);
                            OrderedTimes.Add(keyValuePair.Key);

                        }  // end of foreach
                        TC.categoryname = string.Format("P10:" + SelectedVariable + cat);
                        TC.catname_db = cat;  //Added in Jan2016

                    }  // end of IF
                    #endregion

                    #region P50 CURVE
                    if (P50var == "P50" & q50 == null)
                    {

                        foreach (var keyValuePair in sortedDict1)
                        {
                            var kvalues = sortedDict1[keyValuePair.Key];
                            double N = kvalues.Count;  // number of completions in the current group List
                            double p50 = 50;
                            double n50 = (p50 / 100) * (N - 1) + 1;
                            double K50 = Math.Floor(Math.Abs(n50));         //integer part of n50

                            int d50 = 0;
                            d50 = (int)Math.Round((n50 - Math.Truncate(n50)) * 10);     //Decimal part of n50


                            // P50 Calc---------------------------------------------------
                            double kvalue_5 = 0;
                            var p5 = Convert.ToInt32(K50);
                            p5 = p5 - 1;
                            var kvalue5 = GetItemIfinIndex(p5, kvalues);
                            if (double.IsNaN(kvalue5))                          // check if the value is NULL
                            {
                                kvalue5 = 0;

                            }

                            if (double.IsNaN(GetItemIfinIndex(p5 + 1, kvalues)))    // check if the value is NULL
                            {
                                kvalue_5 = 0;

                            }
                            else
                            {
                                kvalue_5 = GetItemIfinIndex(p5 + 1, kvalues);
                            }
                            double x5 = (Convert.ToDouble(d50)) / 10;
                            var resultP50 = kvalue5 + x5 * (kvalue_5 - kvalue5);
                            OrderedValues.Add(resultP50);
                            OrderedTimes.Add(keyValuePair.Key);
                        }
                        TC.categoryname = string.Format("P50: " + SelectedVariable + " " + cat);
                        TC.catname_db = cat;  //Added in Jan2016
                    }
                    #endregion


                    #region P90 CURVE
                    if (P90var == "P90" & q90 == null)
                    {
                        foreach (var keyValuePair in sortedDict1)
                        {
                            var kvalues = sortedDict1[keyValuePair.Key];
                            double N = kvalues.Count;  // number of completions in the current group List

                            double p90 = 90;
                            double n90 = (p90 / 100) * (N - 1) + 1;
                            double K90 = Math.Floor(Math.Abs(n90));
                            int d90 = 0;
                            d90 = (int)Math.Round((n90 - Math.Truncate(n90)) * 10);     //Decimal part of n90

                            // P90 Calc---------------------------------------------------
                            double kvalue_9 = 0;
                            var p9 = Convert.ToInt32(K90);
                            p9 = p9 - 1;
                            var kvalue9 = GetItemIfinIndex(p9, kvalues);
                            if (double.IsNaN(kvalue9))                          // check if the value is NULL
                            {
                                kvalue9 = 0;

                            }

                            if (double.IsNaN(GetItemIfinIndex(p9 + 1, kvalues)))    // check if the value is NULL
                            {
                                kvalue_9 = 0;

                            }
                            else
                            {
                                kvalue_9 = GetItemIfinIndex(p9 + 1, kvalues);
                            }
                            double x9 = (Convert.ToDouble(d90)) / 10;
                            var resultP90 = kvalue9 + x9 * (kvalue_9 - kvalue9);
                            OrderedValues.Add(resultP90);
                            OrderedTimes.Add(keyValuePair.Key);
                            // End P90 Calc----------------------------------------
                        }
                        TC.categoryname = string.Format("P90: " + SelectedVariable + " " + cat);
                        TC.catname_db = cat;  //Added in Jan2016
                    }
                    #endregion


                    X.FinalResult = OrderedTimes.Select((t, v) => new KeyValuePair<DateTime, double>(t, OrderedValues[v])).ToList();  //new addition

                    if (OrderedValues.Count > 0)
                    {
                        for (int i = 0; i < OrderedValues.Count; i++)
                        {
                            CDFPlot dp = new CDFPlot();
                            dp.dt = OrderedTimes[i];
                            dp.value = OrderedValues[i];
                            dp.elapsedmonths = i;
                            TC.DataPoints.Add(dp);
                        }
                        
                        CDFResults.Add(TC);             // Populate the observable collection
                        CDFPlotCollection.Add(X);
                       
                    }

                } //end of for loop
                #endregion
                //return Results;

                #region findlargestCDFresultsRange
                var Largest = 0;
                for (int m = 0; m < CDFResults.Count; m++)
                {
                    var CurrentCount = CDFResults[m].DataPoints.Count;
                    if (m == 0)
                    {
                        Largest = CurrentCount;
                    }
                    else
                    {
                        if (CurrentCount > Largest)
                        {
                            Largest = CurrentCount;
                        }
                    }
                }

                #endregion

                //foreach (var item in CDFResults)
                //{
                //    for (int i = 0; i < Largest; i++)
                //    {
                //        CDFPlot dp = new CDFPlot();
                //        dp.dt = CDFResults[i].DataPoints[i].dt;
                //        dp.value = CDFResults[i].DataPoints[i].value;
                //        TC.DataPoints.Add(dp);
                //    }
                //}

            }
        #endregion
        }

        #region FUNCTIONS
        public void clearcollection()
        {
            CDFResults.Clear();
            CDFPlotCollection.Clear();
          // UiDriver.FilterClear();   // to clear filter after the clearall button
        }

        public List<string> GetCatValues(String catname)
        {

            string newstring = catname + ".";

            var allCategoryvalues = (from category in Workspace.Categories from categoryValue in category select string.Format("{0}.{1}", category.Name, categoryValue.Name)).ToList();

            var newlist = allCategoryvalues.Where(s => s.Contains(newstring)).Select(s => s.Replace(newstring, "")).ToList();

            return newlist;

        }

        public List<Completion> GetCompletionNames(string SelectedCat, String SelectedCatValue)
        {
            var completionNames = new List<Completion>();
            var entity = Workspace.CurrentFilter;

            foreach (var completion in entity.Completions)
            {
                if (completion.CategoryValues[SelectedCat].Name.Equals(SelectedCatValue))
                {
                    completionNames.Add(completion);
                    
                }
            }
          
            return (completionNames);
        }

        

        public double GetItemIfinIndex(int index, List<double> values)
        {
            var k = double.NaN;
            if (values.Count > index)
            {
                return values[index];
            }
            else
            {
                return k;
            }

        }

        #endregion




    }
}
